function filterJSONRef( contentFilename ){
        let file = filesWithMetadata[contentFilename]
        if (!file) return

        let contentType = file.contentType

        if ( contentType.includes("json") && contentFilename.startsWith("references_manual_") && contentFilename.endsWith(".json")) {
                console.log('it is a manual reference JSON file', contentFilename)
		fetch( contentFilename ).then( r => r.json() ).then( json => {
			let ref = json["data-objects"]
			ref.map( (r, i) => {
				let el = addNewNote( r["bibtex-data"].title, "0 "+(1+i/20)+" -.5" )
				// should be able to specify a parent
				el.id = r["object-id"] 
				el.classList.add("reference-entry")
				el.data = r
				// could add some new interaction onreleased/onpicked
				el.setAttribute("onpicked", "console.log( selectedElements.at(-1).element.id )")
				// el.setAttribute("onreleased", "console.log( selectedElements.at(-1).element.id )")
				// could also toggle show/hide onreleased in a target area or close enough to something else
					// show what though? all? "quick" layout engine?
				let fullEl = addNewNote( Object.entries( r["bibtex-data"] )
					.filter( e => e[1] )
					.map( e => e.join(": "))
					.join("\n") , "-.1 "+(1+i/20)+" -.5" )
				fullEl.setAttribute("color", "black")
				fullEl.setAttribute("outline-width", "0")
				// filtering out empty values
				fullEl.setAttribute("rotation", "45 0 0")
				fullEl.setAttribute("scale", ".01 .01 .01")
				fullEl.classList.add("reference-entry-card")
				fullEl.data = r
				let backgroundEl = document.createElement("a-box")
				backgroundEl.setAttribute("scale", "10 5 .1")
				backgroundEl.setAttribute("position", "4.5 0 -.1")
				fullEl.appendChild( backgroundEl )
				if (r["annote"]) {
					let annoteEl = addNewNoteAsPostItNote( r["annote"], "-.3 "+(1+i/20)+" -.5", ".02 .02 .02" )
					annoteEl.classList.add("reference-entry-annotate")
				}
				if (r["note"]) {
					let annoteEl = addNewNoteAsPostItNote( r["note"], "-.2 "+(1+i/20)+" -.5", ".02 .02 .02" )
					annoteEl.classList.add("reference-entry-note")
				}
				// if ACM and OA might be available via https://dl.acm.org/doi/pdf/DOI
					// could then try to pass as PDF reader argument
						// cf pageAsTextViaXML() and related in index.html
						// note that it'd still need to fetch then upload via WebDAV
				let pdf = r["bibtex-data"]["source-pdf"] 
				let acmoa = r["bibtex-data"]["free-acm-access"] // warning, this is a string, not a boolean
				// fallback due to file structure change between v4 and v11
				if (!pdf) pdf = r["source-pdf"] 
				if (!acmoa) acmoa = r["free-acm-access"]  // warning, this is a string, not a boolean

				if (pdf && acmoa == "true" && pdf.startsWith("https://dl.acm.org")) {

					// could then try to fetch content then upload via WebDAV
							// should skip if already available
					let pdfEl = document.createElement("a-box")
					//pdfEl.setAttribute("scale", ".1 .1 .1")
					pdfEl.setAttribute("position", "-1.2 0 0") // trying to move away in order to be executable
					fullEl.appendChild( pdfEl )
					
					let truncated_filename = pdf.replace(/.*pdf\//,'').replace(/.*\//,'')
					// here by convention it would be in "/saved/pdfxml/"
					let url = "/saved/pdfxml/"+truncated_filename+".xml"
					fetch(url).then( response => {
						if (response.ok) {
							pdfEl.setAttribute( "color", "purple" )
							// could have a showFile() on pinched here
							let openCommandEl = addNewNote( "jxr showFile('"+url+"')", "-.6 "+(1+i/20)+" -.5", '.05 .05 .05' )
							openCommandEl.classList.add("reference-entry-showfile")
						}
					})

					/*
					if (pdf.endsWith( truncated_filename )) {
						pdfEl.setAttribute("color", "green" )
						pdfEl.setAttribute("color", "purple" )
						//pdfEl.setAttribute("value", "jxr console.log('"+truncated_filename+"')" )
							// what should become the target then? the cube?
							// problematic because it becomes movable
						//pdfEl.setAttribute("target", "" )

						// then should add JXR open of target PDF
						
						window.pageastextviaxmlsrc = "https://companion.benetou.fr/saved/pdfxml/"+truncated_filename+".xml"
						pageAsTextViaXML()
						highlightcommands.setAttribute("visible", true)
						roundedpageborders.setAttribute("visible", true)
					}
					*/

				}
			})
		})
        }
        applyNextFilter( contentFilename )
}

sequentialFilters.push( filterJSONRef )
