function filterPDFUnpackedXml( contentFilename ){
	const path = "/saved/pdfxml/"
        let file = filesWithMetadata[contentFilename]
	// might have to hijack again
        if (!file) return

        let contentType = file.contentType

        if ( contentType.includes("xml") && contentFilename.includes("pdfxml/") ) {
                console.log('it is a pdf unpacked file', contentFilename)
		pageAsTextViaXML(contentFilename, page=0)
	}

        applyNextFilter( contentFilename )

	function pageAsTextViaXML(src, page=0){
		fetch( src ).then( r => r.text() ).then( txt => {
		  const rootEl = document.createElement("a-box")
		  file.filteredEl = rootEl
		  rootEl.nextPage = (el) => {
			// not tested in depth
			Array.from( rootEl.querySelectorAll(".highlightabletext") ).map( el => el.remove() )
			Array.from( doc.children[0].children[page++].querySelectorAll("text") ).map( (l,n) => {
				let tktxt = document.createElement("a-troika-text")
				let pos = ""+(l.attributes.left.value*scalingFactor+xOffset) + " " + (1-l.attributes.top.value*scalingFactor+yOffset) + " "+zPos
				let scale = "0.045 0.045 0.045" 
				tktxt.setAttribute("position", pos)
				tktxt.setAttribute("font-size", "0.009")
				tktxt.setAttribute("color", "black")
				tktxt.setAttribute("value", l.textContent)
				tktxt.setAttribute("anchor", "left")
				tktxt.classList.add("highlightabletext")
				rootEl.appendChild(tktxt)
			})
		  }
		  rootEl.previousPage = _ => console.log( 'test' )
		  const sheetEl = document.createElement("a-box")
		  sheetEl.setAttribute("width", "1") 
		  sheetEl.setAttribute("height", "1.2")
		  sheetEl.setAttribute("depth", ".01")
		  sheetEl.setAttribute("position", "0.5 -.6 0")
		  rootEl.appendChild(sheetEl)
		  rootEl.setAttribute("width", ".01") 
		  rootEl.setAttribute("height", ".01")
		  rootEl.setAttribute("depth", ".01")
		  rootEl.setAttribute("color", "brown")
		  rootEl.setAttribute("target", "") // "hidden" by the highlightable texts as targets
			// can temporarily remove target from .highlightabletext elements
			// alternatively could have a handle, a la lens demo
		  let disabledHighlight = true // for testing manipulation
			disabledHighlight=false
			// highlight ball still hidden due to thickness
		  rootEl.setAttribute("position", "-0.5 1.7 -.6") 
		  rootEl.id = "page_from_"+src.replaceAll("https://","").replaceAll("/","_")
		  rootEl.classList.add ( "page_from_pdf" )
		  AFRAME.scenes[0].appendChild(rootEl)

		  const parser = new DOMParser();
		  let doc = parser.parseFromString(txt, "application/xml")
		  const scalingFactor = 1/1000 // used for position of text and images
			// could also use x/y/z offsets
				// probably easier to append to an entity, either empty or used as (white) background
		  const xOffset = 0.1 // changed by rootEl position
		  const yOffset = -1.0
		  const zPos = 0.01
		  //Array.from( doc.children[0].children[page].querySelectorAll("text") ).map( (l,n) => addNewNote(l.textContent, ""+(l.attributes.left.value*scalingFactor+xOffset) + " " + (1-l.attributes.top.value*scalingFactor+yOffset) + " "+zPos, "0.045 0.045 0.045", "highlighttextfromxml_"+n, "highlighttextfromxmlitem" ) )
		  Array.from( doc.children[0].children[page].querySelectorAll("text") ).map( (l,n) => {
			//	addNewNote(l.textContent, ""+(l.attributes.left.value*scalingFactor+xOffset) + " " + (1-l.attributes.top.value*scalingFactor+yOffset) + " "+zPos, "0.045 0.045 0.045", "highlighttextfromxml_"+n, "highlighttextfromxmlitem" ) )
				let tktxt = document.createElement("a-troika-text")
				let pos = ""+(l.attributes.left.value*scalingFactor+xOffset) + " " + (1-l.attributes.top.value*scalingFactor+yOffset) + " "+zPos
				let scale = "0.045 0.045 0.045" 
				tktxt.setAttribute("position", pos)
				tktxt.setAttribute("originalposition", pos)
				tktxt.setAttribute("originalpage", page)
				// FIXME 
				//tktxt.setAttribute("originalsource", fileContent.meta.metadata['dc:title'])
				//tktxt.setAttribute("originalidentifier", fileContent.meta.metadata['dc:identifier'])
				tktxt.setAttribute("font-size", "0.009")
				tktxt.setAttribute("color", "black")
				if (!disabledHighlight) tktxt.setAttribute("target", "")
				tktxt.classList.add("highlightabletext")
				tktxt.setAttribute("onpicked", "console.log(selectedElements.at(-1).element.getAttribute('value'))")
				tktxt.setAttribute("onreleased", "let el = selectedElements.at(-1).element; if (true) el.setAttribute('color', highlightColor); el.setAttribute('rotation', ''); el.setAttribute('position', el.getAttribute('originalposition') )")
					// resets back...
					// change color
						// only if above a certain threshold, e.g. held a long time, or released close to specific other item
					// could also toggle coloring
						// can be based on coloring pick with jxr
				tktxt.setAttribute("value", l.textContent)
				tktxt.setAttribute("anchor", "left")
				rootEl.appendChild(tktxt)
		  })

		  Array.from( doc.children[0].children[page].querySelectorAll("image") ).map( (l,n) => {
			let el = document.createElement("a-box")
			// is position via center of element so should offset it
			el.setAttribute("src", path+l.attributes.src.value);  // somehow set to #transparent... 
			el.setAttribute("width", l.attributes.width.value*scalingFactor); 
			el.setAttribute("height", l.attributes.height.value*scalingFactor); 
			el.setAttribute("depth", .01); 
			el.setAttribute("target", "")
			el.id = "highlightimagefromxml_"+n
			el.classList.add("highlightimagefromxmlitem")
			el.classList.add("highlightabletext")
			let w = l.attributes.width.value*scalingFactor
			let h = l.attributes.height.value*scalingFactor
			el.setAttribute("position", ""+ ""+(w/2+l.attributes.left.value*scalingFactor+xOffset)+" "+ (-h/2+1-l.attributes.top.value*scalingFactor+yOffset)+ " "+zPos)
			rootEl.appendChild(el)
		   })

			AFRAME.scenes[0].emit('pdfxmlloaded', contentFilename)
			// to use the event consider :
			//AFRAME.scenes[0].addEventListener("visualmetajsonloaded", e => console.log(e))

		} ); 

	}

}

sequentialFilters.push( filterPDFUnpackedXml )
